/* Generated by the protocol buffer compiler.  DO NOT EDIT! */
/* Generated from: Route.proto */

#ifndef PROTOBUF_C_Route_2eproto__INCLUDED
#define PROTOBUF_C_Route_2eproto__INCLUDED

#include <protobuf-c/protobuf-c.h>

PROTOBUF_C__BEGIN_DECLS

#if PROTOBUF_C_VERSION_NUMBER < 1000000
# error This file was generated by a newer version of protoc-c which is incompatible with your libprotobuf-c headers. Please update your headers.
#elif 1003001 < PROTOBUF_C_MIN_COMPILER_VERSION
# error This file was generated by an older version of protoc-c which is incompatible with your libprotobuf-c headers. Please regenerate this file with a newer version of protoc-c.
#endif

#include "IPAddress.pb-c.h"
#include "IPAddressOrLabel.pb-c.h"

typedef struct _Path Path;
typedef struct _Route Route;


/* --- enums --- */

typedef enum _Path__PathType {
  /*
   * Packet should be dropped
   */
  PATH__PATH_TYPE__BLACKHOLE = 0,
  /*
   * Packet should generate ICMP unreachable
   */
  PATH__PATH_TYPE__UNREACHABLE = 1,
  /*
   * Packet should be subject to local delivery
   */
  PATH__PATH_TYPE__LOCAL = 2,
  /*
   * Unicast packet forwarding
   */
  PATH__PATH_TYPE__UNICAST = 3
    PROTOBUF_C__FORCE_ENUM_TO_BE_INT_SIZE(PATH__PATH_TYPE)
} Path__PathType;
typedef enum _Route__PayloadType {
  /*
   * For IP routes, n/a. For MPLS routes, either IPv4 or IPv6.
   */
  ROUTE__PAYLOAD_TYPE__UNSPEC = 0,
  ROUTE__PAYLOAD_TYPE__IPV4 = 1,
  ROUTE__PAYLOAD_TYPE__IPV6 = 2
    PROTOBUF_C__FORCE_ENUM_TO_BE_INT_SIZE(ROUTE__PAYLOAD_TYPE)
} Route__PayloadType;

/* --- messages --- */

struct  _Path
{
  ProtobufCMessage base;
  /*
   * The type of the path
   */
  protobuf_c_boolean has_type;
  Path__PathType type;
  /*
   * The nexthop of the path. If omitted this this indicates an
   * attached (interface) route.
   */
  IPAddress *nexthop;
  /*
   * The interface index, as determined by the kernel and
   * advertised in RTM_NEWLINK messages.
   * Currently, this should always be present, since recursive
   * route resolution isn't performed in the dataplane.
   */
  protobuf_c_boolean has_ifindex;
  uint32_t ifindex;
  /*
   * MPLS label stack in host byte order, with labels listed
   * from top-most (closest to L2 header) to bottom-most
   * (closest to payload). Labels should not include
   * implicit-null.
   */
  size_t n_mpls_labels;
  uint32_t *mpls_labels;
  /*
   * Bottom-of-stack only traffic towards this destination
   */
  protobuf_c_boolean has_mpls_bos_only;
  protobuf_c_boolean mpls_bos_only;
  /*
   * Preferred source address for originating packets destined
   * to this path
   */
  IPAddress *preferred_source;
  /*
   * This is a backup path. Without any other indication, this
   * indicates a PIC edge backup path and will only be used if
   * all the primary paths are unusable.
   */
  protobuf_c_boolean has_backup;
  protobuf_c_boolean backup;
  /*
   * Recursive via MPLS label. This indicates that the path can
   * instead be resolved recursively via an MPLS label, instead
   * of directly by nexthop, interface with a label stack.
   */
  protobuf_c_boolean has_via_mpls_label;
  uint32_t via_mpls_label;
  /*
   * The number of non-recursive labels, i.e. which can be
   * replaced by via_mpls_label. Must be <= number of
   * mpls_labels.
   */
  protobuf_c_boolean has_n_non_recursive_labels;
  uint32_t n_non_recursive_labels;
};
#define PATH__INIT \
 { PROTOBUF_C_MESSAGE_INIT (&path__descriptor) \
    , 0, PATH__PATH_TYPE__UNICAST, NULL, 0, 0, 0,NULL, 0, 0, NULL, 0, 0, 0, 0, 0, 0 }


struct  _Route
{
  ProtobufCMessage base;
  /*
   * Prefix address of the route.
   * Currently expected to always be present.
   */
  IPAddressOrLabel *prefix;
  /*
   * The length of the prefix for IP routes
   */
  protobuf_c_boolean has_prefix_length;
  uint32_t prefix_length;
  /*
   * Table ID of the route. This ID encodes both VRF and PBR table IDs
   * Default is RT_TABLE_MAIN
   */
  protobuf_c_boolean has_table_id;
  uint32_t table_id;
  /*
   * The paths of the route. No paths is equivalent to a blackhole
   */
  size_t n_paths;
  Path **paths;
  /*
   * Type of payload carried by this route. Currently applicable
   * only for MPLS routes
   */
  protobuf_c_boolean has_payload_type;
  Route__PayloadType payload_type;
  /*
   * Scope of the route. Crude routing metric, but with higher
   * number being more preferred and lower number being less
   * preferred. Should be < 256. Default is RT_SCOPE_UNIVERSE.
   */
  protobuf_c_boolean has_scope;
  uint32_t scope;
  /*
   * Routing protocol, with well known values defined by
   * linux/rtnetlink.h. Should be < 256. Default is RTPROT_ZEBRA.
   */
  protobuf_c_boolean has_routing_protocol;
  uint32_t routing_protocol;
};
#define ROUTE__INIT \
 { PROTOBUF_C_MESSAGE_INIT (&route__descriptor) \
    , NULL, 0, 0, 0, 254u, 0,NULL, 0, ROUTE__PAYLOAD_TYPE__UNSPEC, 0, 0u, 0, 11u }


/* Path methods */
void   path__init
                     (Path         *message);
size_t path__get_packed_size
                     (const Path   *message);
size_t path__pack
                     (const Path   *message,
                      uint8_t             *out);
size_t path__pack_to_buffer
                     (const Path   *message,
                      ProtobufCBuffer     *buffer);
Path *
       path__unpack
                     (ProtobufCAllocator  *allocator,
                      size_t               len,
                      const uint8_t       *data);
void   path__free_unpacked
                     (Path *message,
                      ProtobufCAllocator *allocator);
/* Route methods */
void   route__init
                     (Route         *message);
size_t route__get_packed_size
                     (const Route   *message);
size_t route__pack
                     (const Route   *message,
                      uint8_t             *out);
size_t route__pack_to_buffer
                     (const Route   *message,
                      ProtobufCBuffer     *buffer);
Route *
       route__unpack
                     (ProtobufCAllocator  *allocator,
                      size_t               len,
                      const uint8_t       *data);
void   route__free_unpacked
                     (Route *message,
                      ProtobufCAllocator *allocator);
/* --- per-message closures --- */

typedef void (*Path_Closure)
                 (const Path *message,
                  void *closure_data);
typedef void (*Route_Closure)
                 (const Route *message,
                  void *closure_data);

/* --- services --- */


/* --- descriptors --- */

extern const ProtobufCMessageDescriptor path__descriptor;
extern const ProtobufCEnumDescriptor    path__path_type__descriptor;
extern const ProtobufCMessageDescriptor route__descriptor;
extern const ProtobufCEnumDescriptor    route__payload_type__descriptor;

PROTOBUF_C__END_DECLS


#endif  /* PROTOBUF_C_Route_2eproto__INCLUDED */
